;Czasy nalezy podawac w jednostkach, do bajtu nalezy wpisac wartosc z przedzialu 1-255
;Jedna sekunda odpowiada okolo 5 jednostek 
led equ p1.6
irled equ p1.7
buz equ p1.3
irdetect equ p3.7
alarm equ p1.1

ljmp start

org 0BH
irq1:
djnz r1,return1
cpl p1.2
mov r1,#255
reti
return1:
jb p1.2,return2
reti
return2:
cpl irled
reti 



org 100H
start:
mov tmod,#00000010B
mov th0,#242
mov r1,#255
setb tr0
setb ea
setb et0
setb led
setb buz
setb irled
setb irdetect

loop:
setb led
setb buz
mov a,#200 	;czas pomiedzy zadzialaniami czuwaka
acall wait


mov r0,#10

mode1:		;faza oczekiwania na reset bez dzwieku
clr led
mov a,#10	;czas zapalenia diody
acall wait
setb led
mov a,#10	;czas zgaszenia diody
acall wait
djnz r0,mode1

mov r0,#10

mode2:		;faza oczekiwania na reset z dzwiekiem
clr led
clr buz
mov a,#1	;czas zapalenia diody i dzwieku z buzzera
acall wait
setb led
setb buz
mov a,#15	;czas zgaszenia diody i braku dzwieku z buzzera
acall wait
djnz r0,mode2

mode3:		;faza alarmu (uzytkownik nie zresetowal czuwaka)
clr alarm	
clr led
clr buz
mov a,#1	;czas zapalenia diody i dzwieku z buzzera
acall wait
setb led
setb buz
mov a,#1	;czas zgaszenia diody i braku dzwieku z buzzera
acall wait
sjmp mode3


wait:
push acc
mov a,#200
time:
push acc
mov a,#226
djnz acc,$
pop acc
djnz acc,time
pop acc
jnb irdetect,loop
djnz acc,wait
ret

end